<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.22.2.22 $
 * $Author: tora60 $
 * $Date: 2008/02/06 23:19:10 $
 */

define('mxAdminFileLoaded', '1');

if (!defined('MX_TIME')) {
    $vstarttime = explode(' ', microtime());
    define('MX_TIME', (float)$vstarttime[1] + (float)$vstarttime[0]);
    unset($vstarttime);
}
// einen Modulnamen verpassen
define('MX_MODULE', 'admin');

// nur zum initialisieren der Variablen, wird durch das Modul ueberschrieben
$GLOBALS['index'] = 0;

// PHP_SELF macht auf manchen Servern Probleme bei mod_rewrite,
// es wird die umgeschriebene URL verwendet anstatt modules.php
// deshalb hier umschreiben
$_SERVER['PHP_SELF'] = preg_replace('#^[\\\\/]+#', '/', dirname($_SERVER['PHP_SELF']) . '/' . basename(__file__));

// Jeder Adminkategorie einen Namen verpassen...
define('MX_ADMINPANEL_SYSTEM', 1);
define('MX_ADMINPANEL_CONTENT', 2);
define('MX_ADMINPANEL_SECURITY', 3);
define('MX_ADMINPANEL_USERS', 4);
define('MX_ADMINPANEL_ADDON', 5);
// ...und dem Anzeigen des Adminpanels ebenfalls :)
define('MX_ADMIN_DISPLAYPANEL_ON', 1);
define('MX_ADMIN_DISPLAYPANEL_OFF', 0);

/**
 * pragmaMx Hauptdatei includen
 */
require_once('mainfile.php');

mxGetLangfile('admin');

if (!isset($mxShowPragmaMxNews)) $mxShowPragmaMxNews = 1; // falls noch gespeichert > einschalten
define('adminpragmamxinfourl', 'http://www.pragmamx.org/infonews.php?v=' . urlencode(MX_VERSION) . '&amp;lang=' . urlencode($GLOBALS['currentlang']) . '');

$pagetitle = _ADMINMENU;

/* Stylesheet in Headbereich integrieren */
if (@file_exists(MX_THEME_DIR . '/style/mx_menu_admin.css')) {
    // falls vorhanden, user css-datei vom theme einbinden
    $theme_admin_css_file = MX_THEME_DIR . '/style/mx_menu_admin.css';
} else {
    $theme_admin_css_file = 'admin/modules/mxMenu/style/mx_menu_admin.css';
}
pmxHeader::add('<style type="text/css" media="all">@import "' . $theme_admin_css_file . '";</style>');

/* admin style.css fuer alle Adminmodule zugaengig machen  */
pmxHeader::add('<style type="text/css" media="all">@import "admin/modules/style/style.css";</style>');
pmxHeader::add('<script type="text/javascript" src="includes/javascript/jscheck.js"></script>');

/**
 */
function login()
{
    mt_srand((double)microtime() * 1000000);
    $xcv = mt_rand();
    mxSessionSetVar('reqcheck', $xcv);
    $formmessage = mxSessionGetVar('formmessage');
    mxSessionDelVar('formmessage');

    include ("header.php");
    OpenTable();
    if ($formmessage) {
        echo "<br />" . $formmessage . "<br><br>";
    }
    echo "<form action=\"admin.php\" method=\"post\" name=\"adminlogin\">"
     . "<fieldset><legend>" . _ADMINLOGIN . "</legend>"
     . "<table border=\"0\">"
     . "<tr><td>" . _ADMINID . "</td>"
     . "<td><input type=\"text\" name=\"aid\" size=\"30\" maxlength=\"25\"></td></tr>"
     . "<tr><td>" . _PASSWORD . "</td>"
     . "<td><input type=\"password\" name=\"pwd\" size=\"30\"></td></tr>"
     . "<tr><td>&nbsp;</td><td>"
     . "<input type=\"hidden\" name=\"op\" value=\"login\">"
     . "<input type=\"hidden\" name=\"check\" value=\"" . MD5($xcv) . "\">"
     . "<input type=\"hidden\" name=\"sess\" value=\"" . MD5(session_id()) . "\">"
     . "<input type=\"hidden\" name=\"uri\" value=\"" . base64_encode(MX_HOME_URL . $_SERVER["REQUEST_URI"]) . "\">"
     . "<input type=\"submit\" value=\"" . _LOGIN . "\">"
     . "</td></tr></table>"
     . "</fieldset></form>";
    echo "<script language='JavaScript' type='text/javascript'>\n<!--\ndocument.adminlogin.aid.focus();\n//-->\n</script>";
    CloseTable();
    include ("footer.php");
}

/**
 * das eigentliche login
 */
function mx_sys_adminlogin($pvs)
{
    global $prefix, $user_prefix;
    $abad = intval(mxSessionGetVar('abad'));
    $pvs['check'] = (empty ($pvs['check'])) ? mt_rand() : $pvs['check']; // sicherstellen, dass $check initialisiert ist
    $welcome = 'admin.php?op=welcome';
    $real_uri = '';
    if (!empty ($pvs['uri'])) {
        $real_uri = base64_decode($pvs['uri']);
        if (preg_match('#^' . preg_quote(MX_HOME_URL) . '(/.*)?#', $real_uri, $matches)) {
            if (!preg_match('#nextlogin_#', $matches[1])) {
                $welcome = $matches[1];
            }
        } else {
            $baduri = true;
        }
    }
    if (md5(session_id()) != $pvs['sess']) {
        $msg = "<br><b>" . _ADMIN_BADLOGIN4 . "</b><br>";
        mxErrorScreen(_ADMIN_BADLOGIN4);
        die();
    } else if (empty ($pvs["aid"]) || empty ($pvs["pwd"])) {
        $msg = "<b>" . _ADMIN_BADLOGIN . "!</b><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" . _ADMIN_BADLOGIN2 . "<br>";
        mxSessionSetVar("formmessage", $msg);
        $location = "admin.php?op=nextlogin_" . $abad;
    } else if (($pvs["check"] != MD5(mxSessionGetVar("reqcheck"))) || (strlen($pvs["aid"]) > 25)) {
        // sofort intruder
        $doblock = 1;
        mxYoubad("Bad Adminlogin - Account: " . $pvs["aid"] . " (no session-check-id)");
        die();
    } else if (empty($pvs["uri"]) || isset($baduri)) {
        // sofort intruder
        $doblock = 0;
        mxYoubad("Bad Adminlogin - Account: " . $pvs["aid"] . " (bad Referer: " . $real_uri . ")");
        die();
    } else {
        $pwd = md5($pvs["pwd"]);
        $qry = "SELECT a.aid AS aid, a.pwd AS pwd, a.admlanguage AS admlanguage, u.*
						          FROM ${prefix}_authors AS a
											LEFT JOIN ${user_prefix}_users AS u
											ON a.user_uid = u.uid
						          WHERE (a.aid='" . mxAddSlashesForSQL(substr($pvs["aid"], 0, 25)) . "');";
        $result = sql_query($qry);
        $adminrow = sql_fetch_array($result);
        if ($adminrow['pwd'] != $pwd) {
            if ($abad > 3)
                mxSecureLog("SecLog", "Bad Adminlogin - Account: " . $pvs["aid"]);
            mxSessionSetVar("abad", $abad + 1);
            $msg = "<b>" . _ADMIN_BADLOGIN . "!</b><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" . _ADMIN_BADLOGIN2 . "<br>";
            mxSessionSetVar("formmessage", $msg);
            $location = "admin.php?op=nextlogin_" . $abad;
        } else {
            $info = base64_encode($adminrow['aid'] . ":" . $adminrow['pwd'] . ":" . $adminrow['admlanguage']);
            mxSessionSafeCookie(MX_SAFECOOKIE_NAME_ADMIN, 1);
            mxSetNukeCookie("admin", $info, 1);
            mxSessionSetVar("admin", $info);
            mxSessionDelVar("abad");
            mxSessionDelVar("formmessage");
            if (empty ($adminrow['uid']) || $adminrow['user_stat'] != 1) {
                $location = "admin.php?op=adminMain";
            } else {
                // setzt den neuen user-cookie
                mxSetUserSession($adminrow["uid"], $adminrow["uname"], $adminrow["pass"], $adminrow["storynum"], $adminrow["umode"], $adminrow["uorder"], $adminrow["thold"], $adminrow["noscore"], $adminrow["ublockon"], $adminrow["theme"], $adminrow["commentmax"]);
                $location = $welcome;
            }
        }
    }
    if ($abad > 8) {
        mxSessionSetVar("abad", $abad -2);
        mxYoubad("Bad Adminlogin - Account: " . $pvs["aid"] . " (bad " . ($abad + 2) . "))");
    }
    mxSessionDelVar("reqcheck");
    mxSessionSetVar("lasttime", 0); // Zuruecksetzen, damit Online ausgefuehrt wird
    session_write_close();
    header("Location: " . $location);
    exit;
}

/* Navigationsfunktionen  BEGIN */

function mxAdminGetNav()
{
    $nav_item = array();
    for($i = 1;$i <= 5;$i++) {
        $nav_item[$i]['class'] = "";
    }
    $nav_item[1]['url'] = "admin.php?panel=system";
    $nav_item[1]['title'] = _SYSTEM;
    $nav_item[2]['url'] = "admin.php?panel=content";
    $nav_item[2]['title'] = _CONTENT;
    $nav_item[3]['url'] = "admin.php?panel=security";
    $nav_item[3]['title'] = _SECURITY;
    $nav_item[4]['url'] = "admin.php?panel=users";
    $nav_item[4]['title'] = _USERS;
    $nav_item[5]['url'] = "admin.php?panel=addon";
    $nav_item[5]['title'] = _ADDON;
    return $nav_item;
}

function adminmenu($url, $title, $image, $panel = MX_ADMINPANEL_ADDON, $target = "_self")
{
    global $myxlink, $admingraphic;

    if ($admingraphic) {
        $img = mxCreateImage("images/admin/$image", strip_tags($title)) . "<br />";
        $width = "16%";
        $height = "6.5em";
    } else {
        $img = "";
        $width = "15%";
        $height = "3.0em";
    }
    // $output = "<td $align><font class=\"content\"><a href=\"$url&amp;panel=$panel\" target=\"$target\">$img $title </a></font></td>";
    $addpanel = ($GLOBALS['adminpanel'] == '1') ? "&amp;panel=" . $panel : "";
    $output = '<div style="float:left; width:' . $width . '; height:' . $height . '; text-align: center;">
             <a href="' . $url . $addpanel . '" target="' . $target . '">' . $img . ' ' . $title . '</a></div>';
    // aus dem Titel und dem generierten Link/Grafik einen gemeinsamen String generieren
    // Teil 1 wird zum Sortieren benoetigt, Teil 2 ist die eigentliche Ausgabe
    // Teil 3 beinhaltet die den jeweiligen Wert der zugehoerigen Kategorie
    $myxlink = $title . "@" . $output . "@" . strval($panel); # neu!! jop :)
}

function mxAdminGetLinks($choice = 0)
{
    global $aid, $admingraphic, $banners, $prefix, $op;
    global $myxlink; # temporaere Variable erstellen, wird in adminmenu() veraendert

    if (empty($op)) {
        $op = "adminMain";
    }
    $admindata = mxGetAdminData();
    // das extract wird in den .link-Dateien benoetigt
    extract($admindata);

    $menulist = "";
    $linkfiles = "";
    $linksdir = dir("admin/links");
    $handle = opendir("admin/links"); # Ordner oeffnen
    $thelinks = array();
    while ($linkfile = readdir($handle)) { // alle Dateien des Ordners durchlaufen
        if (substr($linkfile, 0, 6) == "links.") { // nur bestimmte Dateien ansprechen
            include_once("admin/links/" . $linkfile); # Datei einlesen, hier wird jeweils die funktion adminmenu() ausgefuehrt
            $thelinks[] = $myxlink; # array mit der veraenderten Variablen fuellen
        }
        $myxlink = ""; # temporaere Variable zuruecksetzen
    }
    natsort($thelinks); # array alphabetisch nach Titel sortieren
    $myxlink = ""; # temporaere Variable nochmals zuruecksetzen
    adminmenu("admin.php?op=logout", "" . _ADMINLOGOUT . "", "exit.gif", MX_ADMINPANEL_SYSTEM); # zusaetzlichen Logout Button erzeugen
    $thelinks[] = $myxlink; # und an array anfuegen (am Ende)
    while (list ($key, $xlinkfile) = each ($thelinks)) { // sortiertes array durchlaufen
        $xlinkfile2 = explode("@", $xlinkfile); # den in adminmenu() erzeugten String trennen
        if (!empty($xlinkfile2[1])) { // nur wenn Link auch angezeigt werden soll (Adminberechtigung)
            $linkfile = $xlinkfile2[1]; # daraus nur den Link/die Grafik verwenden
            if (intval($xlinkfile2[2]) == $choice || $choice == 0) {
                $linkfiles .= $linkfile; # das war's, Link/Grafik in String schreiben
            }
        }
    }
    return $linkfiles . '<div style="clear: both;"></div>';
}

function mxAdminGetPanelVal()
{
    $array = array('choice' => 0, 'descr' => "");
    $sess_var = mxSessionGetVar('panel');
    $panel_sv = !empty($sess_var) ? $sess_var : "system";
    if (isset($_GET['op']) && $_GET['op'] == 'DisplayStory' && isset($_GET['qid'])) {
        $_GET['panel'] = "content";
    }
    $panel = empty($_GET['panel']) ? $panel_sv : $_GET['panel'];
    if (!intval($panel) > 0) {
        switch ($panel) {
            case 'content' : $choice = 2;
                $descr = _CONTENT_DESCR;
                break;
            case 'security' : $choice = 3;
                $descr = _SECURITY_DESCR;
                break;
            case 'users' : $choice = 4;
                $descr = _USER_DESCR;
                break;
            case 'addon' : $choice = 5;
                $descr = _ADDON_DESCR;
                break;
            default : $choice = 1;
                $descr = _SYSTEM_DESCR;
                break;
        }
    } else {
        $choice = $panel;
        $descr = isset($_GET['ok']) ? _SYSTEM_DESCR : "";
    }
    if (!isset($_GET['op']) && !isset($_GET['panel']) && empty($sess_var)) {
        $choice = 1;
        $descr = _SYSTEM_DESCR;
    }
    $array['choice'] = $choice;
    $array['descr'] = $descr;
    return $array;
}

function GraphicAdmin()
{
    $adminpanel = intval($GLOBALS['adminpanel']);
    $descr = "";
    $choice = 1;
    OpenTable();
    if ($adminpanel == MX_ADMIN_DISPLAYPANEL_OFF) {
        $panel = 0;
        echo "<div align='center'>\n";
        if (defined('MX_DEMOMODE_RUN')) {
            OpenTableAl();
            echo "<div align='center'><strong>" . _DEMOMODEACTIV . "</strong></div>\n";
            CloseTableAl();
        }
        echo mxAdminGetLinks(0) . "\n</div>\n";
    } elseif ($adminpanel == MX_ADMIN_DISPLAYPANEL_ON) {
        $nav_items = mxAdminGetNav();
        extract(mxAdminGetPanelVal());
        $nav_items[$choice]['class'] = " class='current'";
        mxSessionSetVar('panel', $choice);
        ?>
			<div class="mx_tab">
				<ul class="mx_tabnav">
					<?php foreach($nav_items as $item) :?>
					<li<?php echo $item['class']?>><a href="<?php echo $item['url']?>"><?php echo $item['title']?></a></li>
					<?php endforeach;
        ?>
				</ul>
				<?php echo (!empty($descr)) ? '<div class="hr">' . $descr . '</div>' : '';
        ?>
				<div align="center">
					<?php if (defined('MX_DEMOMODE_RUN')) :?>
					<?php OpenTableAl();
        ?>
						<div align="center"><strong><?php echo _DEMOMODEACTIV ?></strong></div>
					<?php CloseTableAl();
        ?>
					<?php endif;
        ?>
					<?php echo mxAdminGetLinks($choice) ?>
				</div>
				<div style="clear: both;"></div>
			</div>
  	 <?php
    }
    CloseTable();
}

/* Navigationsfunktionen ENDE */

function adminMain()
{
    global $aid, $prefix, $user_prefix, $sitename, $mxShowPragmaMxNews, $bgcolor1, $bgcolor2, $bgcolor3;
    // weitere Infos, nur im System-Tab anzeigen
    if ($GLOBALS['adminpanel'] == '1') {
        $pan = mxAdminGetPanelVal();
        if ($pan['choice'] != 1) {
            include ('header.php');
            GraphicAdmin();
            include ('footer.php');
            return;
        }
    }

    include ("header.php");
    $arrow = mxCreateImage('images/menu/oarrow.gif', '') . '&nbsp;';
    $queryalang = (empty($queryalang)) ? "" : $queryalang;
    $dummy = 0;
    GraphicAdmin();
    $content1 = "";
    if ($GLOBALS['vkpUserregoption'] == 2 || $GLOBALS['vkpUserregoption'] == 4) {
        list($num) = sql_fetch_row(sql_query("select count(uid) from ${user_prefix}_users WHERE user_stat=0"));
        if (!empty($num)) $content1 .= $arrow . "<b>$num</b>&nbsp;<a href=\"admin.php?op=mod_users\">" . _AB_NEWUSERS . "</a><br />";
        $num = 0;
    }
    if (mxModuleAllowed("Submit_News")) {
        list($num) = sql_fetch_row(sql_query("select count(qid) from ${prefix}_queue"));
        if (!empty($num)) $content1 .= $arrow . "<b>$num</b>&nbsp;<a href=\"admin.php?op=submissions\">" . _AB_SUBMISSIONS . "</a><br />";
        $num = 0;
    }
    if (mxModuleAllowed("Reviews")) {
        list($num) = sql_fetch_row(sql_query("select count(id) from ${prefix}_reviews WHERE active='0';"));
        if (!empty($num)) $content1 .= $arrow . "<b>$num</b>&nbsp;<a href=\"admin.php?op=reviews\">" . _WREVIEWS . "</a><br />";
        $num = 0;
    }
    if (mxModuleAllowed("Web_Links")) {
        list($num) = sql_fetch_row(sql_query("select count(lid) from ${prefix}_links_newlink;"));
        if (!empty($num)) $content1 .= $arrow . "<b>$num</b>&nbsp;<a href=\"admin.php?op=Links\">" . _AB_WLINKS . "</a><br />";
        $num = 0;
        list($num) = sql_fetch_row(sql_query("select count(requestid) from ${prefix}_links_modrequest where brokenlink=0;"));
        if (!empty($num)) $content1 .= $arrow . "<b>$num</b>&nbsp;<a href=\"admin.php?op=LinksListModRequests\">" . _AB_MODREQLINKS . "</a><br />";
        $num = 0;
        list($num) = sql_fetch_row(sql_query("select count(requestid) from ${prefix}_links_modrequest where brokenlink=1;"));
        if (!empty($num)) $content1 .= $arrow . "<b>$num</b>&nbsp;<a href=\"admin.php?op=LinksListBroken\">" . _AB_BROKENLINKS . "</a><br />";
        $num = 0;
    }
    if (mxModuleAllowed("Downloads")) {
        list($num) = sql_fetch_row(sql_query("select count(lid) from ${prefix}_downloads_newdownload"));
        if (!empty($num)) $content1 .= $arrow . "<b>$num</b>&nbsp;<a href=\"admin.php?op=Downloads\">" . _AB_UDOWNLOADS . "</a><br />";
        $num = 0;
        list($num) = sql_fetch_row(sql_query("select count(requestid) from ${prefix}_downloads_modrequest where brokendownload=0;"));
        if (!empty($num)) $content1 .= $arrow . "<b>$num</b>&nbsp;<a href=\"admin.php?op=DownloadsListModRequests\">" . _AB_MODREQDOWN . "</a><br />";
        $num = 0;
        list($num) = sql_fetch_row(sql_query("select count(requestid) from ${prefix}_downloads_modrequest where brokendownload=1;"));
        if (!empty($num)) $content1 .= $arrow . "<b>$num</b>&nbsp;<a href=\"admin.php?op=DownloadsListBroken\">" . _AB_BROKENDOWN . "</a><br />";
        $num = 0;
    }
    if (mxModuleAllowed("My_eGallery")) {
        list($num) = sql_fetch_row(sql_query("select count(pid) from ${prefix}_gallery_pictures_newpicture;"));
        if (!empty($num)) $content1 .= $arrow . "<b>$num</b>&nbsp;<a href=\"admin.php?op=GallAdmin\">" . _AB_PICTURES . "</a><br />";
        $num = 0;
    }
    if (mxModuleAllowed("FAQ")) {
        list($num) = sql_fetch_row(sql_query("select count(faq_id) from ${prefix}_faqnew;"));
        if (!empty($num)) $content1 .= $arrow . "<b>$num</b>&nbsp;<a href=\"admin.php?op=FaqAnswerNew\">" . "FAQ's" . "</a><br />";
        $num = 0;
    }
    if (mxModuleAllowed("Guestbook")) {
        list($num) = sql_fetch_row(sql_query("select count(id) from ${prefix}_nukebook_queue;"));
        if (!empty($num)) $content1 .= $arrow . "<b>$num</b>&nbsp;<a href=\"admin.php?op=GuestBookAdmin\">" . _GUESTBOOK . "</a><br />";
        $num = 0;
    }
    if (mxModuleAllowed("Kalender")) {
        list($num) = sql_fetch_row(sql_query("SELECT Count(eid) FROM ${prefix}_events WHERE activ=0;"));
        if (!empty($num)) $content1 .= $arrow . "<b>$num</b>&nbsp;<a href=\"admin.php?op=CalendarAdmin\">" . _AB_EVENTS . "</a><br />";
        $num = 0;
    }
    if (mxModuleAllowed("Webring")) {
        list($num) = sql_fetch_row(sql_query("select count(ringid) from ${prefix}_webring where activ=0;"));
        if (!empty($num)) $content1 .= $arrow . "<b>$num</b>&nbsp;<a href=\"modules.php?name=Webring&ring=1&file=index&mode=adminNewentry\">" . _AB_WEBRING . "</a><br />";
        $num = 0;
    }

    if ($GLOBALS['adminpanel'] == '1') {
        $search = array("op=mod_users", "op=submissions", "op=reviews", "op=Links", "op=LinksListModRequests", "op=LinksListBroken",
            "op=Downloads", "op=DownloadsListModRequests", "op=DownloadsListBroken", "op=GallAdmin", "op=FaqAnswerNew",
            "op=GuestBookAdmin", "op=CalendarAdmin");
        $replace = array("op=mod_users&amp;panel=users", "op=submissions&amp;panel=content", "op=reviews&amp;panel=addon", "op=Links&amp;panel=addon", "op=LinksListModRequests&amp;panel=addon", "op=LinksListBroken&amp;panel=addon",
            "op=Downloads&amp;panel=addon", "op=DownloadsListModRequests&amp;panel=addon", "op=DownloadsListBroken&amp;panel=addon", "op=GallAdmin&amp;panel=addon", "op=FaqAnswerNew&amp;panel=addon",
            "op=GuestBookAdmin&amp;panel=addon", "op=CalendarAdmin&amp;panel=addon");

        $content1 = str_replace($search, $replace, $content1);
    }

    $shownews = '<p>' . $arrow . '<a href="admin.php?op=resetPmxCache"><b>' . _RESETPMXCACHE . '</b></a></p>';
    $shownews .= '<p>' . $arrow . '<a href="admin.php?op=mxvcheck"><b>' . _VERSIONCHECK . '</b></a></p>';
    $shownews .= '<p>' . $arrow . '<a href="http://docs.pragmamx.org/pragmaMx/" target="_blank"><b>pragmaMx Manual</b></a></p>';
    if ($mxShowPragmaMxNews) {
        $shownews .= '<div>' . $arrow . '<b>' . _PRAGMANEWS . ':</b><br /><iframe src="' . adminpragmamxinfourl . '" name="Infonews" id="Infonews" width="250" height="150" marginwidth="3" marginheight="3" frameborder="0" style="border: 1px solid ' . $bgcolor2 . ';"><a href="' . adminpragmamxinfourl . '" target="_blank"><b>' . _SHOWPRAGMANEWS . '</b></a></iframe></div>';
    } else {
        $shownews .= '<div>' . $arrow . '<a href="' . adminpragmamxinfourl . '" target="_blank"><b>' . _SHOWPRAGMANEWS . '</b></a></div>';
    }
    $infolink = (mxGetAdminPref('radminsuper')) ? '&nbsp;&nbsp;<span class="tiny">(<a href="admin.php?op=info" title="PHP-Info">PHP-Info</a>)</span>' : '';

    OpenTable2();
    if ($content1) {
        echo '<div align="center" class="title">' . _NEWSUBMISSIONS . '</div><br /><div align="left" class="content">';
        echo $content1;
        echo '</div>';
    } else {
        echo '<div align="center" class="title">' . _NOSUBMISSIONS . '</div>';
    }
    CloseTable2();
    echo "<br>";
    OpenTable();
    echo '<table cellspacing="1" cellpadding="2" border="0">
	<tr valign="top">
	    <td><b>' . _VERSION_CMS . ':</b></td>
	    <td>' . MX_VERSION . ', ' . MX_VERSION_SUB . '</td>
			<td rowspan="4">' . $shownews . '</td>
	</tr>
	<tr valign="top">
	    <td><b>' . _VERSION_PHP . ':</b></td>
	    <td>' . phpversion() . $infolink . '</td>
	</tr>
	<tr valign="top">
	    <td><b>' . _VERSION_MYSQL . ':</b></td>
	    <td>' . MX_SQL_VERSION . '</td>
	</tr>
	<tr valign="top">
	    <td><b>' . _VERSION_SERVER . ':</b></td>
	    <td>' . $_SERVER['SERVER_SOFTWARE'] . '</td>
	</tr>
	</table>
	';
    CloseTable();
    echo "<br>";
    include ("footer.php");
}

function mxAdminLanguageSelect($name, $curlang = "", $hideall = 0)
{
    $handle = opendir('language');
    while ($file = readdir($handle)) {
        if (preg_match("/^lang\-(.+)\.php/", $file, $matches)) {
            $languageslist[] = $matches[1];
        }
    }
    closedir($handle);
    sort($languageslist);
    $options = "";
    foreach($languageslist as $lang) {
        if (!empty($lang)) {
            $sel = ($lang == $curlang) ? "selected" : "";
            $options .= "<option value=\"$lang\" $sel>" . ucfirst($lang) . "</option>\n";
        }
    }
    if (empty($hideall)) {
        $sel = ($lang == $curlang) ? "selected" : "";
        $options = "<option value=\"\"> " . _ALL . "</option>\n" . $options . "";
    }
    $out = "<select name=\"" . $name . "\">\n" . $options . "</select>\n";
    return $out;
}

function admindologout()
{
    mxSessionSafeCookie(MX_SAFECOOKIE_NAME_ADMIN, 0);
    mxSetNukeCookie("admin");
    mxSessionDelVar("admin");
    if (!MX_IS_USER) {
        mxSessionDestroy();
    } else {
        session_write_close();
    }
    Header("Location: admin.php?op=logoutfin");
}

function admindologoutfin()
{
    mxSessionDelVar("admin");
    mxSessionSetVar("lasttime", 0); // Zuruecksetzen, damit Online ausgefuehrt wird
    mxRedirect('index.php', _YOUARELOGGEDOUT);
}

function getCheckUsersSelectOptions($user_stat = 0)
{
    global $user_prefix, $prefix;
    $user_stat = (int)$user_stat;
    $errmsg = (empty($user_stat)) ? "No New Users available" : "No deactivated Users available";
    $useroptions = "";
    $qry = "SELECT uname, uid
					FROM ${user_prefix}_users
					WHERE ${user_prefix}_users.user_stat = " . $user_stat . "
					ORDER BY ${user_prefix}_users.uname";
    $result = sql_query($qry);
    if ($result) {
        while (list($uname, $uid) = sql_fetch_row($result)) {
            $useroptions .= "<option value=\"" . $uid . "\">" . $uname . "</option>\n";
        }
    }
    $useroptions = (empty($useroptions)) ? "<option value=0>" . $errmsg . "</option>" : $useroptions;
    return $useroptions;
}

function getAllUsersSelectOptions2($currentgroup)
{
    global $user_prefix, $prefix;
    $useroptions = "";
    $qry = "SELECT uname
	        FROM ${user_prefix}_users
					WHERE user_ingroup=" . $currentgroup . " AND user_stat=1
					ORDER BY uname";
    $result = sql_query($qry);
    if ($result) {
        while (list($uname) = sql_fetch_row($result)) {
            $useroptions .= "<option value=\"" . $uname . "\">" . $uname . "</option>";
        }
    }
    $useroptions = (empty($useroptions)) ? "<option value=0>ERROR!!! No Users available</option>" : $useroptions;
    return $useroptions;
}

function getAllAccessLevelSelectOptions($selectedgroup)
{
    global $prefix;
    // Sicherstellen, dass wirklich eine Gruppe vorselektiert werden kann
    if (empty($selectedgroup)) {
        $selectedgroup = array(intval($GLOBALS['default_group']));
    } else if (!is_array($selectedgroup)) {
        $selectedgroup = array(intval($selectedgroup));
    }
    if (empty($selectedgroup[0])) {
        $selectedgroup = array(intval($GLOBALS['default_group']));
    }
    // alle Gruppen auslesen
    $groups = getAllAccessGroups(true);
    // die Optionen zusammenstellen
    foreach ($groups as $key => $row) {
        if ($GLOBALS['default_group'] == $row['access_id']) {
            $row['access_title'] .= '&nbsp;*';
        }
        $sel = (in_array($row['access_id'], $selectedgroup)) ? ' selected="selected"' : '';
        $groupoptions[] = '<option value="' . $row['access_id'] . '"' . $sel . '>' . $row['access_title'] . '</option>';
    }
    // wenn Optionen vorhanden, ansonsten Fehler
    if (isset($groupoptions)) {
        return "\n" . implode("\n", $groupoptions) . "\n";
    } else {
        return '<option value="0">ERROR!!! No Groups available</option>';
    }
}

function getAllAccessGroups($autoinsert = true)
{
    global $prefix;

    $result = sql_query("select access_id, access_title from " . $prefix . "_groups_access where access_title != 'Deleted' order by access_title");
    while ($row = sql_fetch_assoc($result)) {
        $groupoptions[$row['access_id']] = $row;
    }
    if (!isset($groupoptions) || !isset($groupoptions[$GLOBALS['default_group']])) {
        sql_query("INSERT INTO " . $prefix . "_groups_access SET access_title = '" . MX_FIRSTGROUPNAME . "', access_id=" . intval($GLOBALS['default_group']));
        $groupoptions = getAllAccessGroups(false);
    }
    return $groupoptions;
}

function getUserStatOptions($user_stat)
{
    $out = "";
    if (empty($user_stat)) { // nur Anzeigen bei neuen Usern
        $out .= "<option value=0" . (($user_stat == 0) ? " selected" : "") . ">" . _YA_USERSTAT_0 . "</option>\n"; # neu, noch nicht aktiviert
    }
    $out .= "<option value=1" . (($user_stat == 1) ? " selected" : "") . ">" . _YA_USERSTAT_1 . "</option>\n"; # aktiviert
    if (!empty($user_stat)) { // nicht Anzeigen bei neuen Usern
        $out .= "<option value=2" . (($user_stat == 2) ? " selected" : "") . ">" . _YA_USERSTAT_2 . "</option>\n"; # deaktiviert
    }
    return $out;
}

function create_first($pvs)
{
    global $prefix, $user_prefix;
    extract($pvs);
    $first_name = substr($first_name, 0, 25);
    if (!isset($_COOKIE[MX_SESSION_NAME])) {
        // wenn kein Session-Cookie gesetzt wurde
        mxErrorScreen(_ADMIN_BADLOGIN4);
    }
    if (!mxSessionGetVar("create_first") || empty($first_check)) {
        // wenn session bereits geloescht (z.B. bei refresh der page)
        // oder Check-Variable des Formulars fehlt, umleiten
        Header("Location: admin.php");
    }
    // wenn die Funktion nicht ueber das richtige Formular aufgerufen:
    // Intruder und Session blockieren (funktion: vkpIpBanning() in header.php)
    $checkID = md5(mxSessionGetVar("create_first"));
    mxSessionDelVar("create_first");
    if ($first_check != $checkID) {
        $doblock = 1;
        mxYoubad("create_first failed (no session-check-id) - $first_name");
        die();
    }
    // pruefen ob vielleicht doch schon ein God-Account besteht
    $result = sql_query("SELECT count(aid) FROM ${prefix}_authors where name ='God'");
    list($first) = sql_fetch_row($result);
    if ($first == 1) {
        // wenn doch schon einer da ist...
        mxSecureLog("SecLog", "create_first failed (is available) - $first_name");
        mxErrorScreen(_ADMIN_GODEXIST);
    }
    // pruefen ob der Adminname bereits vergeben ist
    $result = sql_query("SELECT count(aid) FROM ${prefix}_authors where aid ='" . mxAddSlashesForSQL($first_name) . "'");
    list($aexist) = sql_fetch_row($result);
    if (!empty($aexist)) {
        $pvs['msg'] = _uaNICKTAKEN . " (" . $first_name . ")";
        unset($pvs['first_name']);
    }
    // nicht alle Felder ausgefuellt?
    else if (empty($first_name) || empty($first_email) || empty($first_pwd) || ereg("[^ a-zA-Z0-9_-]", $first_name)) {
        $pvs['msg'] = _COMPLETEFIELDS;
    }
    // Datenbankpasswort zur Sicherheit ueberpruefen
    // wer das nicht kennt, kann auch kein God sein
    else if ($first_dbpass != $GLOBALS['dbpass']) {
        mxSecureLog("SecLog", "create_first failed (bad dbPass) - $first_name");
        $pvs['msg'] = _ADMIN_ERRDBPASS;
        unset($pvs['first_dbpass']);
    }
    // wenn Fehler-Message, Seite neu aufrufen
    if (isset($pvs['msg'])) {
        // uebergebene Parameter und Fehler-Message in Session schreiben
        mxSessionSetVar("first_data", $pvs);
        session_write_close();
        Header("Location: admin.php");
        exit;
    }
    // Daten in Admintabelle schreiben
    $first_pwd = md5(trim($first_pwd));
    $qry = "INSERT INTO ${prefix}_authors ( aid, name, url, email, pwd, counter, radminsuper )
					VALUES ( '" . mxAddSlashesForSQL($first_name) . "', 'God', '" . mxAddSlashesForSQL($first_url) . "', '" . mxAddSlashesForSQL($first_email) . "', '$first_pwd', 0, 1);";
    $result = sql_query($qry);
    // wenn beim schreiben Fehler aufgetreten
    if (!$result) {
        mxErrorScreen("" . _ADMIN_ERRSQL . "<br /><br />$qry");
    }
    // Soll ein normaler User miterstellt werden?
    if ($first_createuser) {
        // pruefen ob Benutzername bereits vorhanden
        $result = sql_query("select uid from ${user_prefix}_users where uname='" . mxAddSlashesForSQL($first_name) . "'");
        list($uid) = sql_fetch_row($result);
        if (empty($uid)) {
            // wenn nein, neuen Benutzer anlegen
            $user_regdate = mxGetNukeUserregdate();
            $user_regtime = time();
            $qry = "INSERT INTO ${user_prefix}_users
			( uname       , name         , email         , url         , pass        , user_regdate   , user_regtime , user_stat) values
			('$first_name', '" . mxAddSlashesForSQL($first_name) . "', '" . mxAddSlashesForSQL($first_email) . "', '" . mxAddSlashesForSQL($first_url) . "', '$first_pwd', '$user_regdate', $user_regtime, 1);";
            $result = sql_query($qry);
            if ($result) {
                // wenn erfolgreich, eingefuegte uid  ermitteln
                $uid = sql_insert_id();
            }
        }
        // wenn eine gueltige uid vorhanden ist,
        if (!empty($uid)) {
            // diese in die Admintabelle zur Verknuepfung eintragen (selfadmin)
            sql_query("UPDATE ${prefix}_authors SET user_uid=" . intval($uid) . " WHERE aid='" . mxAddSlashesForSQL($first_name) . "'");
        }
    }
    mxSecureLog("SecLog", "create_first: ok - $first_name");
    // Erfolgsnachricht in Session schreiben
    $msg = "<b>" . _ADMIN_GODCREATEOK . "</b><br /><br /><b>" . _uaAsadmin . "</b>: $first_name<br /><b>" . _uaAsuser . "</b>: $first_name";
    mxSessionSetVar("formmessage", $msg);
    mxSessionDelVar("first_data");
    session_write_close();
    // und ab zum login :-))
    Header("Location: admin.php"); // zum Login
}

function checkforgodadmin()
{
    global $prefix;
    $result = sql_query("SELECT aid FROM ${prefix}_authors where name ='God'");
    list($the_first) = sql_fetch_row($result);
    if (empty($the_first)) {
        $first_data = mxSessionGetVar("first_data");
        mxSessionDelVar("first_data");
        mt_srand((double)microtime() * 1000000);
        $xcv = mt_rand();
        mxSessionSetVar("create_first", $xcv);
        include("header.php");
        title($GLOBALS['sitename'] . ": " . _ADMINISTRATION . "");
        OpenTable();
        echo "<center><b>" . _NOADMINYET . "</b></center><br /><br />"
         . ((isset($first_data['msg']))?"<center><b>" . $first_data['msg'] . "</b></center><br /><br />":"")
         . "<form action=\"admin.php\" method=\"post\" name=\"dofirst\">"
         . "<input type=\"hidden\" name=\"op\" value=\"create_first\">"
         . "<input type=\"hidden\" name=\"first_check\" value=\"" . MD5($xcv) . "\" />"
         . "<table border=\"0\">"
         . "<tr><td><b>" . _NICKNAME . ":</b></td><td><input type=\"text\" name=\"first_name\" size=\"40\" maxlength=\"25\" value=\"" . ((isset($first_data['first_name']))?$first_data['first_name']:"") . "\">  <font class=\"tiny\">" . _REQUIRED . "</font></td></tr>"
         . "<tr><td><b>" . _PASSWORD . ":</b></td><td><input type=\"password\" name=\"first_pwd\" size=\"40\" maxlength=\"20\" value=\"" . ((isset($first_data['first_pwd']))?$first_data['first_pwd']:"") . "\">  <font class=\"tiny\">" . _REQUIRED . "</font></td></tr>"
         . "<tr><td><b>" . _EMAIL . ":</b></td><td><input type=\"text\" name=\"first_email\" size=\"40\" maxlength=\"255\" value=\"" . ((isset($first_data['first_email']))?$first_data['first_email']:$GLOBALS['adminmail']) . "\">  <font class=\"tiny\">" . _REQUIRED . "</font></td></tr>"
         . "<tr><td><b>" . _HOMEPAGE . ":</b></td><td><input type=\"text\" name=\"first_url\" size=\"40\" maxlength=\"255\" value=\"" . ((isset($first_data['first_url']))?$first_data['first_url']:MX_HOME_URL) . "\"></td></tr>"
         . "<tr><td colspan=\"2\"><br />" . _CREATEUSERDATA . "  <input type=\"radio\" name=\"first_createuser\" value=\"1\" checked>" . _YES . "&nbsp;&nbsp;<input type=\"radio\" name=\"first_createuser\" value=\"0\">" . _NO . "<br /><br /><br /></td></tr>"
         . "<tr><td><b>" . _DBPASS . "</b></td><td><input type=\"password\" name=\"first_dbpass\" size=\"40\" maxlength=\"20\" value=\"" . ((isset($first_data['first_dbpass']))?$first_data['first_dbpass']:"") . "\">  <font class=\"tiny\">" . _REQUIRED . "</font></td></tr>"
         . "<tr><td colspan=\"2\"><input type=\"submit\" value=\"" . _SUBMIT . "\"></td></tr>"
         . "</table></form>";
        echo "<script language='JavaScript' type='text/javascript'>\n<!--\ndocument.dofirst.first_name.focus();\n//-->\n</script>";
        CloseTable();
        include("footer.php");
        exit;
    }
}

function php_info()
{
    if (!mxGetAdminPref('radminsuper')) {
        mxErrorScreen('<h1>Access Denied</h1>');
        exit;
    }
    if (!empty($GLOBALS['mxDemoMode'])) {
        mxErrorScreen("<h1>not in demoMode->phpinfo()</h1>");
        exit;
    }
    extract(mxGetAdminSession());
    mxSystemInfo();
    exit;
}

$op = (empty($_REQUEST['op'])) ? "adminMain" : $_REQUEST['op'];
if (MX_IS_ADMIN) {
    mxSessionDelVar("abad");
    extract(mxGetAdminSession());

    switch ($op) {
        case "login":
            $op = "adminMain";
        case "adminMain":
        case "welcome":
            adminMain();
            break;
        case "logout":
            admindologout();
            break;
        case "logoutfin":
            mxErrorScreen("<b>Admin-Logout failed</b><br />Please delete your Session-Cookie (" . MX_SESSION_NAME . ") manualy.");
            break;
        case "info":
            php_info();
            break;
        case "mxvcheck":
            include_once('admin/modules/versioncheck.php');
            break;
        case "resetBlockCache":
            include_once('includes/mx_reset.php');
            resetBlockCache();
            break;
        case "resetPmxCache":
            include_once('includes/mx_reset.php');
            resetPmxCache();
            break;
        default:
            // Ausgabepuffer aktivieren um zu pruefen ob die $op-Option vorhanden ist
            ob_start();
            $handle = opendir('admin/case');
            while (false !== ($file = readdir($handle))) {
                if (substr($file, 0, 5) == 'case.') {
                    // Case Datei includen
                    include('admin/case/' . $file);
                }
                // falls jetzt die header und footer.php geladen wurden, kann der Rest der
                // Schleife abgebrochen werden, weil die erwartende Ausgabe stattgefunden hat
                if (isset($GLOBALS['footer_is_shown']) && isset($GLOBALS['header_is_shown'])) {
                    break;
                }
            }
            closedir($handle);
            // Falls Script hier noch nicht beendet und Ausgabepuffer leer,
            // stimmt was nicht, also eine Fehlermeldung zu generieren
            $fileoutput = trim(ob_get_clean());
            if (empty($fileoutput)) {
                mxErrorScreen(sprintf(_OPNOTAVAILABLE, $op));
                exit;
            }
            echo $fileoutput;
            break;
    } # end switch
} else {
    if ($op != "create_first" && empty($_POST['first_check'])) {
        checkforgodadmin();
    }
    switch ($op) {
        case "logoutfin":
            admindologoutfin();
            break;
        case "login":
            mx_sys_adminlogin($_POST);
            break;
        case "create_first":
            create_first($_POST);
            break;
        default:
            login();
    } # end switch
}

?>
